/*
 * Generated by XDoclet - Do not edit!
 */
package hero.interfaces;

/**
 * Local interface for UserSession.
 * @copyright INRIA
 * @xdoclet-generated at ${TODAY}
 * @copyright The XDoclet Team
 * @author XDoclet
 * @version 3.1
 */
public interface UserSessionLocal
   extends javax.ejb.EJBLocalObject
{
   /**
    * Get user project list. Workflow processes associated to this user (models/cooperative/instances)
    * @return a Collection of BnProjectLightValue objects - the projects list of the user
    * @throws HeroException
    */
   public java.util.Collection getProjectList(  ) throws hero.util.HeroException;

   /**
    * Get project list names for this user (models/cooperative/instances)
    * @return a String Collection - the projects list names of the user
    * @throws HeroException
    */
   public java.util.Collection getProjectListNames(  ) throws hero.util.HeroException;

   /**
    * Get user instances list. This method is equivalent to getProjectList but it only returns the current instances of the user.
    * @return a Collection of BnProjectLightValue objects - the projects list of the user
    * @throws HeroException
    */
   public java.util.Collection getInstancesList(  ) throws hero.util.HeroException;

   /**
    * Get user instances list. This method is equivalent to getProjectList but it only returns the current instances of the user.
    * @return a Collection of BnProjectLightValue objects - the projects list of the user
    * @throws HeroException
    */
   public java.util.Collection getInstancesList( int offset,int numrows ) throws hero.util.HeroException;

   /**
    * Get user model list. This method is equivalent to getProjectList but it only returns the current models of the user.
    * @return a Collection of BnProjectLightValue objects - the model list of the user
    * @throws HeroException
    */
   public java.util.Collection getModelList(  ) throws hero.util.HeroException;

   /**
    * Get available workflow models. This method will be improved with users restrictions
    * @return a Collection of BnProjectLightValue objects - the model list to be instantiated
    * @throws HeroException
    */
   public java.util.Collection getModels(  ) throws hero.util.HeroException;

   /**
    * Get available workflow models. This method is like getModels() except that no initiatorMapper check is performed.
    * @return a Collection of BnProjectLightValue objects - the model list
    * @throws HeroException
    */
   public java.util.Collection getModelsLight(  ) throws hero.util.HeroException;

   /**
    * Get available workflow models. This method is like getModels() except that no initiatorMapper check is performed.
    * @return a Collection of BnProjectLightValue objects - the model list
    * @throws HeroException
    */
   public java.util.Collection getModelsLightAll(  ) throws hero.util.HeroException;

   /**
    * Get available workflow models. This method will be improved with users restrictions
    * @return a Collection of BnProjectLightValue objects - the model list to be instantiated
    * @throws HeroException
    */
   public java.util.Collection getModelsAsPK(  ) throws hero.util.HeroException;

   /**
    * Get available workflow models. This method will be improved with users restrictions
    * @return a Collection of BnProjectLightValue objects - the model list to be instantiated
    * @throws HeroException
    */
   public java.util.Collection getModelsByPK( java.util.Collection list,int offset,int numrows ) throws hero.util.HeroException;

   /**
    * Get available workflow models. This method is like getModels() except that no initiatorMapper check is performed.
    * @return a Collection of BnProjectLightValue objects - the model list
    * @throws HeroException
    */
   public java.util.Collection getModelsLightAsPK(  ) throws hero.util.HeroException;

   /**
    * Get available workflow models. This method is like getModels() except that no initiatorMapper check is performed.
    * @return a Collection of BnProjectLightValue objects - the model list
    * @throws HeroException
    */
   public java.util.Collection getModelsLightByPK( java.util.Collection list,int offset,int numrows ) throws hero.util.HeroException;

   /**
    * Get user cooperative projects list. This method is equivalent to getProjectList but it only returns the current cooperative projects of the user.
    * @return a Collection of BnProjectLightValue objects - the cooperative projects list of the user
    * @throws HeroException
    */
   public java.util.Collection getCooperativeList(  ) throws hero.util.HeroException;

   /**
    * Get user cooperative projects list. This method is equivalent to getProjectList but it only returns the current cooperative projects of the user.
    * @return a Collection of BnProjectLightValue objects - the cooperative projects list of the user
    * @throws HeroException
    */
   public java.util.Collection getCooperativeList( int offset,int numrows ) throws hero.util.HeroException;

   /**
    * Get instances list names for this user. This method is equivalent to getProjectListNames but it only returns the current instances of the user.
    * @return a String Collection - the projects list names of the user
    * @throws HeroException
    */
   public java.util.Collection getInstancesListNames(  ) throws hero.util.HeroException;

   /**
    * Get instances list names for this user. This method is equivalent to getProjectListNames but it only returns the current instances of the user.
    * @return a String Collection - the projects list names of the user
    * @throws HeroException
    */
   public java.util.Collection getInstancesListNames( int offset,int numrows ) throws hero.util.HeroException;

   /**
    * Delete a Workflow project
    * @param projectName the name of the project
    * @throws HeroException
    */
   public void removeProject( java.lang.String projectName ) throws hero.util.HeroException;

   /**
    * Delete a Workflow project
    * @param instName the name of the instance
    * @throws HeroException
    */
   public void removeInstance( java.lang.String instName ) throws hero.util.HeroException;

   /**
    * Delete a Workflow project
    * @param projectName the name of the project
    * @throws HeroException
    */
   public void removeProject( java.lang.String projectName,java.lang.String version ) throws hero.util.HeroException;

   /**
    * Obtain all user activities from specific project (ready and anticipable state)
    * @param projectName the name of the project
    * @return a String Collection - the list of todo activities of the user for a project
    * @throws HeroException
    */
   public java.util.Collection getToDoList( java.lang.String projectName ) throws hero.util.HeroException;

   /**
    * Obtain all user activities from specific project (ready and anticipable state)
    * @param projectName the name of the project
    * @return a String Collection - the list of todo activities of the user for a project
    * @throws HeroException
    */
   public java.util.Collection getToDoListAsPK( java.lang.String projectName ) throws hero.util.HeroException;

   /**
    * Obtain all user activities from specific project (ready and anticipable state)
    * @param projectName the name of the project
    * @return a String Collection - the list of todo activities of the user for a project
    * @throws HeroException
    */
   public java.util.Collection getToDoListByPK( java.lang.String projectName,java.util.Collection list,int offset,int numrows ) throws hero.util.HeroException;

   /**
    * Obtain all user activities from specific project (executing and anticipating state)
    * @param projectName the name of the project
    * @return a String Collectio - the list of active activities of the user for a project
    * @throws HeroException
    */
   public java.util.Collection getActivityList( java.lang.String projectName ) throws hero.util.HeroException;

   /**
    * Obtain all user activities from specific project (executing and anticipating state)
    * @param projectName the name of the project
    * @return a String Collectio - the list of active activities of the user for a project
    * @throws HeroException
    */
   public java.util.Collection getActivityListAsPK( java.lang.String projectName ) throws hero.util.HeroException;

   /**
    * Obtain all user activities from specific project (executing and anticipating state)
    * @param projectName the name of the project
    * @return a String Collectio - the list of active activities of the user for a project
    * @throws HeroException
    */
   public java.util.Collection getActivityListByPK( java.lang.String projectName,java.util.Collection list,int offset,int numrows ) throws hero.util.HeroException;

   /**
    * Obtain todo user activities for all instances/cooperative projects (ready and anticipable state)
    * @return a BnNodeValue Collection - the list of todo activities of the user for all instances
    * @throws HeroException
    */
   public java.util.Collection getToDoListAllInstances(  ) throws hero.util.HeroException;

   /**
    * Obtain todo user activities for all instances/cooperative projects (ready and anticipable state)
    * @return a BnNodeValue Collection - the list of todo activities of the user for all instances
    * @throws HeroException
    */
   public java.util.Collection getToDoListAllInstancesAsPK(  ) throws hero.util.HeroException;

   /**
    * Obtain todo user activities for all instances/cooperative projects (ready and anticipable state)
    * @return a BnNodeValue Collection - the list of todo activities of the user for all instances
    * @throws HeroException
    */
   public java.util.Collection getToDoListAllInstancesByPK( java.util.Collection list,int offset,int numrows ) throws hero.util.HeroException;

   /**
    * Obtain executing user activities for all instances/cooperative projects (executing and anticipating state)
    * @return a BnNodeValue Collection - the list of executing activities ot the user for all instances
    * @throws HeroException
    */
   public java.util.Collection getActivityListAllInstances(  ) throws hero.util.HeroException;

   /**
    * Obtain executing user activities for all instances/cooperative projects (executing and anticipating state)
    * @return a BnNodeValue Collection - the list of executing activities ot the user for all instances
    * @throws HeroException
    */
   public java.util.Collection getActivityListAllInstancesAsPK(  ) throws hero.util.HeroException;

   /**
    * Obtain executing user activities for all instances/cooperative projects (executing and anticipating state)
    * @return a BnNodeValue Collection - the list of executing activities ot the user for all instances
    * @throws HeroException
    */
   public java.util.Collection getActivityListAllInstancesByPK( java.util.Collection list,int offset,int numrows ) throws hero.util.HeroException;

   /**
    * Obtain terminated user activities for all instances/cooperative projects.
    * @return a BnNodeValue Collection - the list of terminated activities ot the user for all instances
    * @throws HeroException
    */
   public java.util.Collection getTerminatedListAllInstances(  ) throws hero.util.HeroException;

   /**
    * Obtain a subset of the terminated user activities for all instances/cooperative projects.
    * @return a BnNodeValue Collection - the list of terminated activities ot the user for all instances
    * @throws HeroException
    */
   public java.util.Collection getTerminatedListAllInstancesAsPK(  ) throws hero.util.HeroException;

   /**
    * Obtain a subset of the terminated user activities for all instances/cooperative projects.
    * @return a BnNodeValue Collection - the list of terminated activities ot the user for all instances
    * @throws HeroException
    */
   public java.util.Collection getTerminatedListAllInstancesByPK( java.util.Collection list,int offset,int numrows ) throws hero.util.HeroException;

   /**
    * Obtain todo user activities matching with project property value (ready and anticipable state activities)
    * @return a BnNodeValue Collection - the list of todo activities matching to project property value
    * @param key the key of the property
    * @param value the value of the property
    * @throws HeroException
    */
   public java.util.Collection getToDoListByProperty( java.lang.String key,java.lang.String value ) throws hero.util.HeroException;

   /**
    * Obtain todo user activities matching with project property value (ready and anticipable state activities)
    * @return a BnNodeValue Collection - the list of todo activities matching to project property value
    * @param key the key of the property
    * @param value the value of the property
    * @throws HeroException
    */
   public java.util.Collection getToDoListByPropertyAsPK( java.lang.String key,java.lang.String value ) throws hero.util.HeroException;

   /**
    * Obtain todo user activities matching with project property value (ready and anticipable state activities)
    * @return a BnNodeValue Collection - the list of todo activities matching to project property value
    * @param key the key of the property
    * @param value the value of the property
    * @throws HeroException
    */
   public java.util.Collection getToDoListByPropertyByPK( java.lang.String key,java.lang.String value,java.util.Collection list,int offset,int numrows ) throws hero.util.HeroException;

   /**
    * Obtain todo user activities matching with project properties (ready and anticipable state activities)
    * @return a BnNodeValue Collection - the list of todo activities matching to property value. This method is oriented to administrative workflow (workflow instances) and supports one, two or three properties (key/value pairs). Operation constants values: hero.interfaces.Constants.AND, hero.interfaces.Constants.OR
    * @param operation AND/OR operations are allowed.
    * @param properties Hashtable containing the key/value elements
    * @throws HeroException
    */
   public java.util.Collection getToDoListByProperties( int operation,java.util.Hashtable properties ) throws hero.util.HeroException;

   /**
    * Obtain todo user activities matching with project properties (ready and anticipable state activities)
    * @return a BnNodeValue Collection - the list of todo activities matching to property value. This method is oriented to administrative workflow (workflow instances) and supports one, two or three properties (key/value pairs). Operation constants values: hero.interfaces.Constants.AND, hero.interfaces.Constants.OR
    * @param operation AND/OR operations are allowed.
    * @param properties Hashtable containing the key/value elements
    * @throws HeroException
    */
   public java.util.Collection getToDoListByPropertiesAsPK( int operation,java.util.Hashtable properties ) throws hero.util.HeroException;

   /**
    * Obtain todo user activities matching with project properties (ready and anticipable state activities)
    * @return a BnNodeValue Collection - the list of todo activities matching to property value. This method is oriented to administrative workflow (workflow instances) and supports one, two or three properties (key/value pairs). Operation constants values: hero.interfaces.Constants.AND, hero.interfaces.Constants.OR
    * @param operation AND/OR operations are allowed.
    * @param properties Hashtable containing the key/value elements
    * @throws HeroException
    */
   public java.util.Collection getToDoListByPropertiesByPK( int operation,java.util.Hashtable properties,java.util.Collection list,int offset,int numrows ) throws hero.util.HeroException;

   /**
    * Obtain todo user activities matching with activity property value (ready and anticipable state activities)
    * @return a BnNodeValue Collection - the list of todo activities matching to activity property value
    * @param key the key of the property
    * @param value the value of the property
    * @throws HeroException
    */
   public java.util.Collection getToDoListByActivityProperty( java.lang.String key,java.lang.String value ) throws hero.util.HeroException;

   /**
    * Obtain todo user activities matching with activity property value (ready and anticipable state activities)
    * @return a BnNodeValue Collection - the list of todo activities matching to activity property value
    * @param key the key of the property
    * @param value the value of the property
    * @throws HeroException
    */
   public java.util.Collection getToDoListByActivityPropertyAsPK( java.lang.String key,java.lang.String value ) throws hero.util.HeroException;

   /**
    * Obtain todo user activities matching with activity property value (ready and anticipable state activities)
    * @return a BnNodeValue Collection - the list of todo activities matching to activity property value
    * @param key the key of the property
    * @param value the value of the property
    * @throws HeroException
    */
   public java.util.Collection getToDoListByActivityPropertyByPK( java.lang.String key,java.lang.String value,java.util.Collection list,int offset,int numrows ) throws hero.util.HeroException;

   /**
    * Obtain executing user activities matching with property value (executing and anticipating state activities)
    * @return a BnNodeValue Collection - the list of executing activities matching to property value
    * @param key the key of the property
    * @param value the value of the property
    * @throws HeroException
    */
   public java.util.Collection getActivityListByProperty( java.lang.String key,java.lang.String value ) throws hero.util.HeroException;

   /**
    * Obtain executing user activities matching with property value (executing and anticipating state activities)
    * @return a BnNodeValue Collection - the list of executing activities matching to property value
    * @param key the key of the property
    * @param value the value of the property
    * @throws HeroException
    */
   public java.util.Collection getActivityListByPropertyAsPK( java.lang.String key,java.lang.String value ) throws hero.util.HeroException;

   /**
    * Obtain executing user activities matching with property value (executing and anticipating state activities)
    * @return a BnNodeValue Collection - the list of executing activities matching to property value
    * @param key the key of the property
    * @param value the value of the property
    * @throws HeroException
    */
   public java.util.Collection getActivityListByPropertyByPK( java.lang.String key,java.lang.String value,java.util.Collection list,int offset,int numrows ) throws hero.util.HeroException;

   /**
    * Get workflow instances names of this project
    * @param projectName the name of the project
    * @param version the name of the version
    * @return a String Collection - the names of project instances
    * @throws HeroException
    */
   public java.util.Collection getProjectInstancesNames( java.lang.String projectName,java.lang.String version ) throws hero.util.HeroException;

   /**
    * Get workflow instances names of this project
    * @param projectName the name of the project
    * @return a String Collection - the names of project instances
    * @throws HeroException
    */
   public java.util.Collection getProjectInstancesNames( java.lang.String projectName ) throws hero.util.HeroException;

   /**
    * Get workflow instances names of this project
    * @param projectName the name of the project
    * @param version the name of the version
    * @return a String Collection - the names of project instances
    * @throws HeroException
    */
   public java.util.Collection getProjectInstancesNamesAsPK( java.lang.String projectName,java.lang.String version ) throws hero.util.HeroException;

   /**
    * Get workflow instances names of this project
    * @param projectName the name of the project
    * @return a String Collection - the names of project instances
    * @throws HeroException
    */
   public java.util.Collection getProjectInstancesNamesAsPK( java.lang.String projectName ) throws hero.util.HeroException;

   /**
    * Get workflow instances names of this project
    * @param projectName the name of the project
    * @return a String Collection - the names of project instances
    * @throws HeroException
    */
   public java.util.Collection getProjectInstancesNamesByPK( java.lang.String projectName,java.util.Collection list,int offset,int numrows ) throws hero.util.HeroException;

   /**
    * Get Workflow instances of this project
    * @return a BnProjectValue Collection - list of project instances
    * @param projectName the name of the project
    * @param version the name of the version
    */
   public java.util.Collection getProjectInstances( java.lang.String projectName,java.lang.String version ) throws hero.util.HeroException;

   /**
    * Get Workflow instances of this project
    * @return a BnProjectValue Collection - list of project instances
    * @param projectName the name of the project
    */
   public java.util.Collection getProjectInstances( java.lang.String projectName ) throws hero.util.HeroException;

   /**
    * Get Workflow instances of this project
    * @return a BnProjectValue Collection - list of project instances
    * @param projectName the name of the project
    * @param version the name of the version
    */
   public java.util.Collection getProjectInstancesAsPK( java.lang.String projectName,java.lang.String version ) throws hero.util.HeroException;

   /**
    * Get Workflow instances of this project
    * @return a BnProjectValue Collection - list of project instances
    * @param projectName the name of the project
    */
   public java.util.Collection getProjectInstancesAsPK( java.lang.String projectName ) throws hero.util.HeroException;

   /**
    * Get Workflow instances of this project
    * @return a BnProjectValue Collection - list of project instances
    * @param projectName the name of the project
    */
   public java.util.Collection getProjectInstancesByPK( java.lang.String projectName,java.util.Collection list,int offset,int numrows ) throws hero.util.HeroException;

   /**
    * Get Workflow instances from a property
    * @return a BnProjectValue Collection - list of project instances
    * @param projectName the name of the project
    */
   public java.util.Collection getInstancesByProperty( java.lang.String key,java.lang.String value ) throws hero.util.HeroException;

   /**
    * Get Workflow instances from a property
    * @return a BnProjectValue Collection - list of project instances
    * @param projectName the name of the project
    */
   public java.util.Collection getInstancesByPropertyAsPK( java.lang.String key,java.lang.String value ) throws hero.util.HeroException;

   /**
    * Get Workflow instances from a property
    * @return a BnProjectValue Collection - list of project instances
    * @param projectName the name of the project
    */
   public java.util.Collection getInstancesByPropertyByPK( java.lang.String key,java.lang.String value,java.util.Collection list,int offset,int numrows ) throws hero.util.HeroException;

   /**
    * Get Workflow instances from a property
    * @return a String Collection - list of project instances
    * @param projectName the name of the project
    */
   public java.util.Collection getInstancesByPropertyNames( java.lang.String key,java.lang.String value ) throws hero.util.HeroException;

   /**
    * Get Workflow instances from a property
    * @return a String Collection - list of project instances
    * @param projectName the name of the project
    */
   public java.util.Collection getInstancesByPropertyNamesAsPK( java.lang.String key,java.lang.String value ) throws hero.util.HeroException;

   /**
    * Get Workflow instances from a property
    * @return a String Collection - list of project instances
    * @param projectName the name of the project
    */
   public java.util.Collection getInstancesByPropertyNamesByPK( java.lang.String key,java.lang.String value,java.util.Collection list,int offset,int numrows ) throws hero.util.HeroException;

   /**
    * Get Workflow projects from a property
    * @return a BnProjectValue Collection - list of projects
    * @param projectName the name of the project
    */
   public java.util.Collection getProjectsByProperty( java.lang.String key,java.lang.String value ) throws hero.util.HeroException;

   /**
    * Get Workflow projects from a property
    * @return a BnProjectValue Collection - list of projects
    * @param projectName the name of the project
    */
   public java.util.Collection getProjectsByPropertyAsPK( java.lang.String key,java.lang.String value ) throws hero.util.HeroException;

   /**
    * Get Workflow projects from a property
    * @return a BnProjectValue Collection - list of projects
    * @param projectName the name of the project
    */
   public java.util.Collection getProjectsByPropertyByPK( java.lang.String key,java.lang.String value,java.util.Collection list,int offset,int numrows ) throws hero.util.HeroException;

   /**
    * Get Workflow projects from a property
    * @return a String Collection - list of project names
    * @param projectName the name of the project
    */
   public java.util.Collection getProjectsByPropertyNames( java.lang.String key,java.lang.String value ) throws hero.util.HeroException;

   /**
    * Get Workflow projects from a property
    * @return a String Collection - list of project names
    * @param projectName the name of the project
    */
   public java.util.Collection getProjectsByPropertyNamesAsPK( java.lang.String key,java.lang.String value ) throws hero.util.HeroException;

   /**
    * Get Workflow projects from a property
    * @return a String Collection - list of project names
    * @param projectName the name of the project
    */
   public java.util.Collection getProjectsByPropertyNamesByPK( java.lang.String key,java.lang.String value,java.util.Collection list,int offset,int numrows ) throws hero.util.HeroException;

   /**
    * Get activities names of the model instances assigned to this user
    * @param projectName the name of the project
    * @return a String Collection - the names of activities
    * @throws HeroException
    */
   public java.util.Collection getModelInstancesTodoList( java.lang.String projectName ) throws hero.util.HeroException;

   /**
    * Get activities names of the model instances assigned to this user
    * @param projectName the name of the project
    * @return a String Collection - the names of activities
    * @throws HeroException
    */
   public java.util.Collection getModelInstancesTodoList( java.lang.String projectName,int offset,int numrows ) throws hero.util.HeroException;

   /**
    * Get activities names of the model instances terminated by this user
    * @param projectName the name of the project
    * @return a String Collection - the names of activities
    * @throws HeroException
    */
   public java.util.Collection getModelInstancesTerminated( java.lang.String projectName ) throws hero.util.HeroException;

   /**
    * Get activities names of the model instances terminated by this user
    * @param projectName the name of the project
    * @return a String Collection - the names of activities
    * @throws HeroException
    */
   public java.util.Collection getModelInstancesTerminated( java.lang.String projectName,int offset,int numrows ) throws hero.util.HeroException;

   /**
    * Get activities model instances assigned to this user
    * @param projectName the name of the project
    * @param nodeName the name of the node
    * @return a BnNodeLightValue Collection - the values
    * @throws HeroException
    */
   public java.util.Collection getInstancesActivityTodoList( java.lang.String projectName,java.lang.String nodeName ) throws hero.util.HeroException;

   /**
    * Get subset of activities model instances assigned to this user
    * @param projectName the name of the project
    * @param nodeName the name of the node
    * @return a BnNodeLightValue Collection - the values
    * @throws HeroException
    */
   public java.util.Collection getInstancesActivityTodoListAsPK( java.lang.String projectName,java.lang.String nodeName ) throws hero.util.HeroException;

   /**
    * Get subset of activities model instances assigned to this user
    * @param projectName the name of the project
    * @param nodeName the name of the node
    * @return a BnNodeLightValue Collection - the values
    * @throws HeroException
    */
   public java.util.Collection getInstancesActivityTodoListByPK( java.lang.String projectName,java.lang.String nodeName,java.util.Collection list,int offset,int numrows ) throws hero.util.HeroException;

   /**
    * Get activities model instances terminated by this user
    * @param projectName the name of the project
    * @param nodeName the name of the node
    * @return a BnNodeLightValue Collection - the values
    * @throws HeroException
    */
   public java.util.Collection getInstancesActivityTerminated( java.lang.String projectName,java.lang.String nodeName ) throws hero.util.HeroException;

   /**
    * Get subset of activities model instances terminated by this user
    * @param projectName the name of the project
    * @param nodeName the name of the node
    * @return a BnNodeLightValue Collection - the values
    * @throws HeroException
    */
   public java.util.Collection getInstancesActivityTerminatedAsPK( java.lang.String projectName,java.lang.String nodeName ) throws hero.util.HeroException;

   /**
    * Get subset of activities model instances terminated by this user
    * @param projectName the name of the project
    * @param nodeName the name of the node
    * @return a BnNodeLightValue Collection - the values
    * @throws HeroException
    */
   public java.util.Collection getInstancesActivityTerminatedByPK( java.lang.String projectName,java.lang.String nodeName,java.util.Collection list,int offset,int numrows ) throws hero.util.HeroException;

   /**
    * Get models names which have ongoing instances for this user
    * @return a String Collection - the names of workflow models
    * @throws HeroException
    */
   public java.util.Collection getUserInstancesProject(  ) throws hero.util.HeroException;

   /**
    * Get instance names for this user
    * @return a String Collection - the names of workflow instances
    * @throws HeroException
    */
   public java.util.Collection getUserRealInstancesProject(  ) throws hero.util.HeroException;

   /**
    * Get model version for this user and project
    * @return a String - the version of workflow model
    * @throws HeroException
    */
   public java.lang.String getUserModelVersion( java.lang.String proj ) throws hero.util.HeroException;

   /**
    * Get models names which have ongoing instances for this user
    * @return a String Collection - the names of workflow models
    * @throws HeroException
    */
   public java.util.Collection getUserInstancesProject( int offset,int numrows ) throws hero.util.HeroException;

   /**
    * Get ready, anticipable and executing activities for current user instances
    * @param projectName the project name
    * @return a String Collection - the names of activities
    * @throws HeroException
    */
   public java.util.Collection getUserInstancesProjectNodes( java.lang.String projectName ) throws hero.util.HeroException;

   /**
    * Get ready and executing activities for a user instance
    * @param instanceName the project name
    * @param userName the caller's name
    * @return a String Collection - the names of activities
    * @throws HeroException
    */
   public java.util.Collection getInstanceNodes( java.lang.String instanceName,java.lang.String userName ) throws hero.util.HeroException;

   /**
    * Get a subset of the ready, anticipable and executing activities for current user instances
    * @param projectName the project name
    * @return a String Collection - the names of activities
    * @throws HeroException
    */
   public java.util.Collection getUserInstancesProjectNodesAsPK( java.lang.String projectName ) throws hero.util.HeroException;

   /**
    * Get a subset of the ready, anticipable and executing activities for current user instances
    * @param projectName the project name
    * @return a String Collection - the names of activities
    * @throws HeroException
    */
   public java.util.Collection getUserInstancesProjectNodesByPK( java.lang.String projectName,java.util.Collection list,int offset,int numrows ) throws hero.util.HeroException;

   /**
    * Tries to start an activity (when activity state is ready or anticipable)
    * @param projectName the name of the project
    * @param nodeName the name of the node
    */
   public void startActivity( java.lang.String projectName,java.lang.String nodeName ) throws hero.util.HeroException;

   /**
    * Tries to terminate an activity (when activity state is executing or anticipating)
    * @param projectName the name of the project
    * @param nodeName the name of the node
    */
   public void terminateActivity( java.lang.String projectName,java.lang.String nodeName ) throws hero.util.HeroException;

   /**
    * Tries to cancel an activity (when activity is executing or anticipating)
    * @param projectName the name of the project
    * @param nodeName the name of the node
    */
   public void cancelActivity( java.lang.String projectName,java.lang.String nodeName ) throws hero.util.HeroException;

   /**
    * Tries to terminate a project (only when all project activities are terminated)
    * @param projectName the name of the project
    * @param version the name of the instance
    * @throws HeroException
    */
   public void terminate( java.lang.String projectName ) throws hero.util.HeroException;

   /**
    * Get Node Value from a specific project
    * @return a NodeValue object - get node information
    * @param projectName the name of the project
    * @param nodeName the name of the node
    */
   public hero.interfaces.BnNodeValue getNode( java.lang.String projectName,java.lang.String nodeName ) throws hero.util.HeroException;

   /**
    * Get the user name
    * @return a String - get user name
    */
   public java.lang.String getUser(  ) ;

   /**
    * Get the user light value
    * @return a BnUserLightValue object - get user information
    */
   public hero.interfaces.BnUserLightValue getUserLightValue(  ) throws hero.util.HeroException;

   /**
    * Set the mail of this user into Bonita database.
    * @param userName the name of the user
    * @param userName the mail of the user
    * @throws HeroException    */
   public void setUserMail( java.lang.String userName,java.lang.String mail ) throws hero.util.HeroException;

   /**
    * Get the mail of this user from Bonita database.
    * @throws HeroException    */
   public java.lang.String getUserMail(  ) throws hero.util.HeroException;

   /**
    * Get the user password
    * @return a String - get user password
    */
   public java.lang.String getUserPassword(  ) throws hero.util.HeroException;

   /**
    * Get the user jabber address
    * @return a String - get user jabber address
    */
   public java.lang.String getUserJabber(  ) throws hero.util.HeroException;

   /**
    * Get User properties
    * @return a BnUserPropertyValue Collection - list of user properties
    */
   public java.util.Collection getUserProperties(  ) throws hero.util.HeroException;

   /**
    * Set a property of a user
    * @param key the key of the property
    * @param value the name of the property
    */
   public void setUserProperty( java.lang.String key,java.lang.String value ) throws hero.util.HeroException;

   /**
    * Delete a property of a user
    * @param key the key of the property
    */
   public void deleteUserProperty( java.lang.String key ) throws hero.util.HeroException;

}
